---
import HeadCommon from '../components/HeadCommon.astro';
import HeadSEO from '../components/HeadSEO.astro';
import Header from '../components/Header/Header.astro';
import PageContent from '../components/PageContent/PageContent.astro';
import LeftSidebar from '../components/LeftSidebar/LeftSidebar.astro';
import RightSidebar from '../components/RightSidebar/RightSidebar.astro';
import * as config from '../config';

const { frontmatter = {}, headings } = Astro.props;
const canonicalURL = new URL(Astro.url.pathname, Astro.site);
let currentPage = Astro.url.pathname;
if (currentPage.endsWith("/")) {
    currentPage = currentPage.slice(0, currentPage.length - 1)
}
const currentFile = config.Files[currentPage];

const githubEditUrl = config.EditUrl + currentFile;
---

<html dir={frontmatter.dir ?? 'ltr'} lang={frontmatter.lang ?? 'en-us'} class="initial">
	<head>
        <link rel="stylesheet" href="https://theme.higenku.org/style.css">
        
        <!-- algolia search -->
        <script src="https://cdn.jsdelivr.net/npm/@docsearch/js@3"></script>
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@docsearch/css@3">

		<HeadCommon />
		<HeadSEO {frontmatter} canonicalURL={canonicalURL} />
		<title>
			{frontmatter.title ? `${frontmatter.title} - ${config.Site.title}` : config.Site.title}
		</title>
		<style>
			body {
				width: 100%;
				display: grid;
				grid-template-rows: var(--theme-navbar-height) 1fr;
				--gutter: 0.5rem;
				--doc-padding: 2rem;
			}
			.layout {
				display: grid;
				grid-auto-flow: column;
				grid-template-columns:
					minmax(var(--gutter), 1fr)
					minmax(0, var(--max-width))
					minmax(var(--gutter), 1fr);
				overflow-x: hidden;
			}
			.layout :global(> *) {
				width: 100%;
				height: 100%;
			}
			.grid-sidebar {
				height: 100vh;
				position: sticky;
				top: 0;
				padding: 0;
			}
			#grid-left {
				position: fixed;
				background-color: var(--page-sidebar-bac);
				z-index: 10;
				display: none;
			}
			#grid-main {
				padding: var(--doc-padding) var(--gutter);
				grid-column: 2;
				display: flex;
				flex-direction: column;
				height: 100%;
			}
			#grid-right {
				display: none;
			}
			:global(.mobile-sidebar-toggle) {
				overflow: hidden;
			}
			:global(.mobile-sidebar-toggle) #grid-left {
				display: block;
				top: 2rem;
			}
			@media (min-width: 50em) {
				.layout {
					overflow: initial;
					grid-template-columns:
						20rem
						minmax(0, var(--max-width));
					gap: 1em;
				}
				#grid-left {
					display: flex;
					padding-left: 2rem;
					position: sticky;
					grid-column: 1;
				}
			}

			@media (min-width: 72em) {
				.layout {
					grid-template-columns:
						20rem
						minmax(0, var(--max-width))
						18rem;
					padding-left: 0;
					padding-right: 0;
					/* margin: 0 auto; */
				}
				#grid-right {
					grid-column: 3;
					display: flex;
				}
			}
		</style>
	</head>

	<body class="theme-dark">
		<Header currentPage={currentPage}  />
		<main class="layout">
			<aside id="grid-left" class="grid-sidebar" title="Site Navigation">
				<LeftSidebar currentPage={currentPage} />
			</aside>
			<div id="grid-main">
				<PageContent {frontmatter} {headings} {githubEditUrl}>
					<slot />
				</PageContent>
			</div>
			<aside id="grid-right" class="grid-sidebar" title="Table of Contents">
				<RightSidebar {headings} {githubEditUrl} />
			</aside>
		</main>
	</body>
</html>
